Issue 79797 - Enable Persian Numbering support
Enable Persian Numbering support
Status: CLOSED FIXED
Product: Internationalization
Classification: Code
Component: i18npool
OOo 2.2.1
All All
: P3 trivial (vote)
: ---
Assigned To: frank
issues@l10n
:
Depends on:
Blocks: 96765
  Show dependency treegraph
 
Reported: 2007-07-19 15:58 UTC by hamidi
Modified: 2013-08-07 15:01 UTC (History)
2 users (show)

See Also:
Issue Type: ENHANCEMENT
Latest Confirmation on: ---
Developer Difficulty: ---


Attachments
Patch to add Persian native numbering for lists, page numbers, etc. (4.86 KB, patch)
2007-07-21 15:47 UTC, farzaneh
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this issue.
Description hamidi 2007-07-19 15:58:20 UTC
It is not possible to have numbered items in Persian digits or alphabetics. This
error is seen in numbered lists, page numbers, footnote numbers and so on.
Comment 1 stefan.baltzer 2007-07-20 11:28:32 UTC
SBA: This is an enhancement in the framework/i18n component.-> Changed issue
type, component and summary accordingly.
SBA->ER: As discussed, please proceed, thanks.
Comment 2 ooo 2007-07-20 13:32:06 UTC
These may actually be several different things. First, a native numbering using
Persian digits instead of ASCII digits is not implemented. Then, are we talking
also about numbering and outline numbering? For that, new constants would had to
be added to offapi/com/sun/star/style/NumberingType.idl and LC_NumberingLevel
and LC_OutLineNumberingLevel in i18npool/source/localedata/data/fa_IR.xml would
had to be adapted. However, someone in the know would had to specify what types
of numbering are actually used with Persian.

Cc'ing 'farzanehs': Farzaneh, what are the plans about completing the support of
Persian?

  Eike
Comment 3 farzaneh 2007-07-21 15:27:05 UTC
I have been working on it. I have a patch in hand that worked quite well when I
tested it with 2.0.1.

I will attach it here, but it needs to be ported on later versions.
Comment 4 farzaneh 2007-07-21 15:47:00 UTC
Created attachment 46962 [details]
Patch to add Persian native numbering for lists, page numbers, etc.
Comment 5 farzaneh 2007-07-21 15:58:04 UTC
The above patch, as Eike has mentioned, also needs proper changes to the locale
file, e. g. adding the NumType="37" as the NumberingLevels. (This patch sets
CHARS_PERSIAN_LETTERS = 37.)
Comment 6 ooo 2007-07-23 11:54:00 UTC
Great! That patch looks good in general. Of course it needs adapting to current
sources, e.g. the last style::NumberingType value used currently is 45,
scheduling this for OOo2.4

Btw, I wonder why you didn't submit the patch earlier? 

Thanks
  Eike
Comment 7 farzaneh 2007-07-23 13:29:55 UTC
Thanks, Eike. I'll take some time to port it to the new sources.

The reason I didn't submit it earlier was that I wasn't quite sure about its
quality and I thought it still had room for improvement (not to mention my being
busy with my just-accomplished Masters thesis.)

Particularly, there are different numbering systems used in Iran that I thought
would be useful to implement, and the letter numbering was still slightly buggy.
Comment 8 ooo 2007-10-25 14:27:09 UTC
Ready-for-QA before UI/feature freeze of OOo2.4 is nearing (next week). If the
existing patch applies more or less (with minor corrections) neatly to the
SRC680_m234 code base I'll include it. Otherwise I'll have to retarget this
issue to 3.x.
Comment 9 ooo 2007-10-29 18:44:01 UTC
In cws locales24:

offapi/com/sun/star/style/NumberingType.idl  1.16.196.1
i18npool/source/defaultnumberingprovider/defaultnumberingprovider.cxx  1.27.72.1
i18npool/source/nativenumber/nativenumbersupplier.cxx  1.24.102.1
i18npool/source/nativenumber/data/numberchar.h  1.12.118.1

Note that I renamed the API constant from CHARS_PERSIAN_LETTERS to CHARS_PERSIAN
to match other usage of the CHARS_ prefix with/without LETTER. The value now is
46. Also slightly rearranged things in i18npool, no modification of bullet.h,
table data added to defaultnumberingprovider.cxx

@farzanehs: Adapting LC_NumberingLevel and LC_OutLineNumberingLevel is still
pending, please submit a new issue with a patch for fa_IR.xml when ready.

Thanks
  Eike
Comment 10 ooo 2007-11-02 18:13:57 UTC
Reassigning to QA for verification.
Comment 11 frank 2007-11-09 13:22:54 UTC
found fixed on cws locales24
Comment 12 frank 2007-12-11 11:24:23 UTC
found integrated on master m239